
/* SRF08 register defines */

/* six sonar modules on I2C bus two 1.8K resistors needed */

#define CMPS03_ADDR	0xC0 /* Factory supplied default address */
#define TPA81_ADDR	0xD0 /* IR Thermal Sensor */
#define	LCD03_ADDR	0xC6;/* LCD03 */

#define COMMAND_REG     0x00  // Write register
#define GAIN_REG        0x01  // Write register
#define RANGE_REG       0x02  // Write register

#define SRF08_VERSION	0x00  // Read register
#define SRF08_LIGHT     0x01  // Read register
#define SRF08_ECHO_1    0x02
#define SRF08_ECHO_2    0x04
#define SRF08_ECHO_3    0x06
#define SRF08_ECHO_4    0x08
#define SRF08_ECHO_5    0x0A
#define SRF08_ECHO_6    0x0C
#define SRF08_ECHO_7    0x0E
#define SRF08_ECHO_8    0x10
#define SRF08_ECHO_9    0x12
#define SRF08_ECHO_10   0x14
#define SRF08_ECHO_11   0x16

#define SRF08_ECHO_12   0x18
#define SRF08_ECHO_13   0x1A
#define SRF08_ECHO_14   0x1C
#define SRF08_ECHO_15   0x1E
#define SRF08_ECHO_16   0x20
#define SRF08_ECHO_17   0x22
#define SRF08_INVALID   0xFF


#define DIST_IN_INCH    0x50
#define DIST_IN_CM      0x51
#define DIST_IN_US      0x52

#define MAX_RANGE_30CM  0x06  // (43 mm *  6) + 43 mm =  30.1 cm
#define MAX_RANGE_47CM  0x0A  // (43 mm * 10) + 43 mm =  47.3 cm
#define MAX_RANGE_103CM 0x17  // (43 mm * 23) + 43 mm = 103.2 cm

#define GAIN_30CM       0x00
#define GAIN_47CM       0x05
#define GAIN_103CM      0x20


/* CMPS03 register defines */

#define CMPS03_REV		0	/* 8? */
#define CMPS03_BEAR_B	1
#define CMPS03_BEAR_W	2
#define CMPS03_TEST_1	3
#define CMPS03_CAL_DONE	14	/* 0 uncalibrated, 255 done IGNORE for rev 7? */
#define CMPS03_CALIB	15	/* write 255 to enter cal, 0 to exit cal */


/* TPA81 register defines */

#define TPA81_SERVO_CMD	0  // Write register
#define TPA81_SERVO_RNG	1

#define TPA81_REV		0  // Read register
#define TPA81_AMBIENT	1
#define TPA81_PIXEL1	2
#define TPA81_PIXEL2	3
#define TPA81_PIXEL3	4
#define TPA81_PIXEL4	5
#define TPA81_PIXEL5	6
#define TPA81_PIXEL6	7
#define TPA81_PIXEL7	8
#define TPA81_PIXEL8	9



/* I2C FSM States */

#define RANGE_IDLE			0
#define RANGE_START			1
#define RANGE_START_OK		2
#define RANGE_SEN			3
#define RANGE_ADDR			4
#define RANGE_WR_WAIT		5
#define RANGE_STOP			6
#define RANGE_STOP_WAIT		7
#define RANGE_TIMER    		8
#define RANGE_START2		9
#define RANGE_START_OK2		10
#define RANGE_SEN2			11
#define RANGE_ADDR2_WAIT   	12
#define RANGE_REG2_WAIT		13
#define RANGE_RESTART_WAIT	14
#define RANGE_ADDR_RD_WAIT	15
#define RANGE_WAIT_BF		16
#define RANGE_ACK_WAIT		17
//#define RANGE_WAIT_BF2	18
#define RANGE_ACK_WAIT2		19
#define RANGE_WAIT_END		20
//#define RANGE_COMPLETE	21
//#define LIGHT_WAIT_BF		22
#define RANGE_STOP2			23
#define RANGE_RESET2		24
#define RANGE_INVALID		255


/* Prototypes */

/* I2C task routines */
extern void I2C_Tasks(void);
extern void ResetI2Cbus(void);
extern char ReadI2C_Data(unsigned char I2Caddr, unsigned char I2Creg, unsigned char BytesToRead, char *Buff);
extern char SendI2C_Cmd(unsigned char I2Caddr, unsigned char I2Creg, unsigned char I2Cdata);

/* I2C Data */
extern signed   int  SRF08_Range;
extern unsigned char SRF08_Light;
extern unsigned char SRF08_Ver;
extern unsigned int  CMPS03_Heading;
extern unsigned char CMPS03_Ver;
extern unsigned char SRF08GainSelect;



